<script lang="ts">
  import OtherPlayerHand from "./OtherPlayerHand.svelte";
  import Discards from "./Discards.svelte";
  import { isActing } from "./actions/actionUtils";
  import SpeechComponent from "./Speech.svelte";
  import Favor from "./icons/Favor.svelte";
  import type { Player, Phase, Speech } from "../server";
  export let playerState: Player;
  export let phase: Phase;
  export let speech: Speech;

  $: thinking = isActing(phase, playerState.id);
</script>

<div class="wrapper" class:dead={playerState.hand.length === 0}>
  <div class="hand">
    <OtherPlayerHand hand={playerState.hand} />
  </div>

  <gs6-player-box playerid={playerState.id} speaking={speech} {thinking}>
    <div class="box-content">
      <Favor /> ✕ {playerState.score}
      {#if playerState.protected}
        <div class="protection">
          <span class="shield emoji">🛡</span>
        </div>
      {/if}
    </div>

    {#if speech}
      <div slot="speech">
        <SpeechComponent {speech} />
      </div>
    {/if}
  </gs6-player-box>

  <div class="discards">
    <Discards crossfade cards={playerState.discards} />
  </div>
</div>

<style>
  .dead {
    filter: grayscale(90%) opacity(80%);
  }

  .wrapper {
    position: relative;
    display: flex;
    margin-bottom: 4em;
    margin-top: 5em;
    margin-left: 0.75em;
    margin-right: 0.75em;
  }

  @keyframes spin {
    100% {
      transform: rotate(360deg);
    }
  }

  .hand {
    position: absolute;
    left: 50%;
    transform: translateX(-50%);
    font-size: 0.5em;
    top: -10em;
  }

  .box-content {
    text-align: center;
  }

  .protection {
    font-size: 250%;

    position: absolute;
    left: 0;
    top: 50%;
    transform: translate(-50%, -50%) translateX(0.25rem);
  }

  .discards {
    font-size: 0.4rem;
    position: absolute;
    left: 50%;
    bottom: 0;
    transform: translate(-50%, 100%) translateY(-0.5rem);
  }
</style>
